#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>

using namespace std;

#define endl			'\n'

string s[1111];

int main( int argc, char *argv[] ) {
	cin.tie( 0 ); cin.sync_with_stdio( 0 );
	freopen( "input.txt", "r", stdin );
	freopen( "output.txt", "w", stdout );
	int h, w;
	cin >> h >> w;
	int n, m;
	cin >> n >> m;
	for( int i = 0; i < n; i ++ ) {
		cin >> s[i];
		while( s[i].size() != w ) {
			string c = s[i];
			reverse( c.begin(), c.end() );
			s[i] += c;
		}
	}
	while( n != h ) {
		for( int i = 0, j = 2 * n - 1; i < n; i ++, j -- ) {
			s[j] = s[i];
		}
		n <<= 1;
	}
	while( m != w ) {
		m <<= 1;
	}
	int q;
	cin >> q;
	for( int i = 0; i < q; i ++ ) {
		int x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		x1 --, y1 --;
		cout << ( s[x1][y1] == 'X' ? 1 : 0 ) << endl;
	}
	return 0;
}
