#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>

using namespace std;

#define endl			'\n'

string s[1111];
int cnt[1111][1111];

int main( int argc, char *argv[] ) {
	cin.tie( 0 ); cin.sync_with_stdio( 0 );
	freopen( "input.txt", "r", stdin );
	freopen( "output.txt", "w", stdout );
	int h, w;
	cin >> h >> w;
	int n, m;
	cin >> n >> m;
	for( int i = 0; i < n; i ++ ) {
		cin >> s[i];
		while( s[i].size() != w ) {
			string c = s[i];
			reverse( c.begin(), c.end() );
			s[i] += c;
		}
	}
	while( n != h ) {
		for( int i = 0, j = 2 * n - 1; i < n; i ++, j -- ) {
			s[j] = s[i];
		}
		n <<= 1;
	}
	while( m != w ) {
		m <<= 1;
	}
	cnt[0][0] = ( s[0][0] == 'X' );
	for( int i = 1; i < n; i ++ ) {
		cnt[i][0] = cnt[i-1][0] + ( s[i][0] == 'X' );
	}
	for( int j = 1; j < m; j ++ ) {
		cnt[0][j] = cnt[0][j-1] + ( s[0][j] == 'X' );
	}
	for( int i = 1; i < n; i ++ ) {
		for( int j = 1; j < m; j ++ ) {
			cnt[i][j] = cnt[i-1][j] + cnt[i][j-1] - cnt[i-1][j-1] + ( s[i][j] == 'X' );
		}
	}

	int q;
	cin >> q;
	for( int i = 0; i < q; i ++ ) {
		int x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		x1 --, y1 --;
		x2 --, y2 --;
		int ans = cnt[x2][y2];
		if( x1 )
			ans -= cnt[x1-1][y2];
		if( y1 )
			ans -= cnt[x2][y1-1];
		if( x1 && y1 )
			ans += cnt[x1-1][y1-1];
		cout << ans << endl;
	}
	return 0;
}
