#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>

using namespace std;

#define endl			'\n'

string s[1111];

int get( int x, int h, int n ) {
	while( h != n ) {
		h >>= 1;
		if( x >= h )
			x = h - 1 - ( x - h );
	}
	return x;
}

int main( int argc, char *argv[] ) {
	cin.tie( 0 ); cin.sync_with_stdio( 0 );
	freopen( "input.txt", "r", stdin );
	freopen( "output.txt", "w", stdout );
	int h, w;
	cin >> h >> w;
	int n, m;
	cin >> n >> m;
	for( int i = 0; i < n; i ++ ) {
		cin >> s[i];
	}
	int q;
	cin >> q;
	for( int i = 0; i < q; i ++ ) {
		int x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		x1 --, y1 --;
		x2 --, y2 --;
		int cnt = 0;
		for( int i = x1; i <= x2; i ++ ) {
			for( int j = y1; j <= y2; j ++ ) {
				int x = get( i, h, n );
				int y = get( j, w, m );
				cnt += ( s[x][y] == 'X' );
			}
		}
		cout << cnt << endl;
	}
	return 0;
}
